import { RemoteMethodCall, Result } from 'coderitter-api-remote-method-call';
import { MethodCall } from './MethodCall';
/**
 * A remote method call API. It is a simple mapping from a method name to
 * an endpoint which calls the method.
 */
export declare class RemoteMethodApi {
    methods: {
        [methodName: string]: MethodCall | ((remoteMethodCall: RemoteMethodCall) => Promise<Result>);
    };
    /**
     * Get all the message id that can be handled
     */
    get methodNames(): string[];
    /**
     * Executes the method which was called remotely.
     *
     * @param remoteMethodCall May be on object of type RemoteMethodCall or a JSON string containing an object matching the type RemoteMethodCall
     */
    callMethod(remoteMethodCall: RemoteMethodCall): Promise<Result>;
    onMethodError(e: any, remoteMethodCall: RemoteMethodCall): Result;
    onRemoteMethodNotSupported(remoteMethodCall: RemoteMethodCall): Result;
}
